<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

chdir('../../');
include(dirname(__FILE__) . "/../../include/config.php");
include_once($config["base_path"] . "/plugins/thold/thold-functions.php");
include_once($config["base_path"] . "/lib/snmp.php");
include_once($config["base_path"] . "/lib/ping.php");

$db = mysql_connect("$database_hostname", "$database_username", "$database_password");
mysql_select_db("$database_default",$db);

$uptimearray = "SELECT
	host.id,
	host.hostname,
	host.description,
	host.snmp_community,
	host.snmp_version,
	host.snmp_username,
	host.snmp_password,
	host.snmp_port,
	host.snmp_timeout,
	manage_host.uptime,
	manage_host.statut,
	manage_host.force,
	manage_host.thresold_ref,
	manage_host.thresold
	FROM (host, manage_host)
	WHERE manage = 'on'
	AND disabled <> 'on'
	AND host.id=manage_host.id";

$gg = $argv[1];

$pp = " and (";
for ($i=2;$i<$argc;$i++) {
	$pp .= " host.id ='".$argv[$i]. "' || ";
}
$pp .= " host.hostname ='')";

$uptimearray = $uptimearray.$pp;
$queryrows   = db_fetch_assoc($uptimearray) or die (mysql_error() );

foreach ($queryrows as $q_row) {
	print "id : " . $q_row["id"];

	$reboot = '0';

	$old_uptime = $q_row["uptime"];

	if ($old_uptime == "") {
		$old_uptime = "0";
	}

	print " , statut was : " . $q_row["statut"];

	$result = "";
	$method = read_config_option("manage_method");
	print " , method : " . $method;

	if ( ($q_row["force"] <> $method) and ($q_row["force"] <> "9") and ($q_row["force"] <> "") )  {
		$method = $q_row["force"];
		print " -> new method : " . $method;
	}

	switch ($method){
	case "0" :
		$result = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.3.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);

		break;
	case "1" :
		$result = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.1.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);

		break;
	case "2" :     //udp ping
		$ping = new Net_Ping;
		$ping->host["hostname"] = $q_row["hostname"];
		$ping->ping(3, 2, 400, 1);

		if ($ping) {
			$result = "OK";
		}else{
			$result = "";
		}

		break;
	case "3" :      //icmp ping
		$ping = new Net_Ping;
		$ping->host["hostname"] = $q_row["hostname"];
		$ping->ping(3, 1, 400, 1);

		if ($ping) {
			$result = "OK";
		}else{
			$result = "";
		}

		break;
	}

	print " , result : ".$result."\n";
	$new_uptime = "";

	if ( ($result == "") || ($result == "U") ) {
		print "Host : " . $q_row["hostname"] . " (" . $q_row["description"] . ") is not responding !";
		$r="down";
	}else{
		if ($method == "0"){
			$new_uptime = $result;
		}

		if ($method == "1") {
			$new_uptime = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.3.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
		}

		if ($new_uptime == "") {
			$new_uptime = "0";
		}

		print "Host : " . $q_row["hostname"] . " (" . $q_row["description"] . "), old uptime is : " . $old_uptime . ", new is : " . $new_uptime."\n";
		$r="up";
	}




/*
  if ($q_row["statut"] == $r) {
    print " -> nothing to do...\n";
  } else {
    print "\n";
    db_execute("UPDATE manage_host SET statut = '" . $r ."' where id='" . $q_row["id"] . "'");
    if ($r == 'down') {
      db_execute("UPDATE manage_tcp SET statut = 'down' where id='" . $q_row["id"] . "'");
      db_execute("UPDATE manage_services SET statut = 'down' where id='" . $q_row["id"] . "'");
      db_execute("UPDATE manage_process SET statut = 'down' where id='" . $q_row["id"] . "'");
    }
    if ( ( ($q_row["statut"] <> 'prob')  and ($r <> 'prob') ) || ($r == 'down') ) {
      manage_logger("", $q_row["id"], $r, "Host is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "host", "");
    }
  }
*/

	if ($r == 'down') {
		db_execute("UPDATE manage_host SET thresold = '" . ($q_row["thresold"]+1) ."' where id='" . $q_row["id"] . "'");
		print "\ntreshold is now: ".($q_row["thresold"]+1)."\n";

		if (($q_row["thresold"]+1) == "1") {
			db_execute("UPDATE manage_host SET statut = 'treshold' where id='" . $q_row["id"] . "'");
		}

		if (($q_row["thresold"]+1) == $q_row["thresold_ref"]) {
			db_execute("UPDATE manage_host SET statut = 'down' where id='" . $q_row["id"] . "'");
			db_execute("UPDATE manage_host SET statut = 'down' where id='" . $q_row["id"] . "'");
			db_execute("UPDATE manage_tcp SET statut = 'down' where id='" . $q_row["id"] . "'");
			db_execute("UPDATE manage_services SET statut = 'down' where id='" . $q_row["id"] . "'");
			db_execute("UPDATE manage_process SET statut = 'down' where id='" . $q_row["id"] . "'");
			manage_logger("", $q_row["id"], $r, "Host is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "host", "");
		}
	}

	if ($r == 'up') {
		if ( ($q_row["statut"] == 'down') || ($q_row["statut"] == 'prob') ) {
			db_execute("UPDATE manage_host SET statut = '" . $r ."' where id='" . $q_row["id"] . "'");
			manage_logger("", $q_row["id"], $r, "Host is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "host", "");
		}

		db_execute("UPDATE manage_host SET uptime = '" . $new_uptime ."', thresold = '0', statut = 'up' where id='" . $q_row["id"] . "'");
		
		if ($new_uptime < $old_uptime) {
			manage_logger("", $q_row["id"], "rebooted", "Host has ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "host", "");
			$reboot = '1';
		}

		$uptimearray3 = "SELECT * FROM manage_tcp where id='" . $q_row["id"] . "'";
		$queryrows3 = db_fetch_assoc($uptimearray3);

		global $config, $database_default;
		$p = dirname(__FILE__);

		foreach ($queryrows3 as $q_row3) {
			print " + port " . $q_row3["services"] . " , was " . $q_row3["statut"];

			if ($gg == "rrdtool") {
				$uptimearray42 = "SELECT manage_poller_output.output, data_local.id, data_local.data_template_id, data_local.snmp_index FROM data_local, data_template, manage_poller_output WHERE data_local.host_id = '".$q_row["id"]."' AND data_local.data_template_id = data_template.id AND data_template.name = 'TCP' AND manage_poller_output.local_data_id = data_local.id AND data_local.snmp_index = '".$q_row3["services"]."'";
				$queryrows42 = db_fetch_assoc($uptimearray42);
				$r2 = "down";

				foreach ($queryrows42 as $q_row42) {
					if ($q_row42["output"] == "1") {
						$r2 = "up";
						print " (Data_local_id is : ".$q_row42['id'].")\n";
					}
				}

				db_execute("delete from `manage_poller_output` where `local_data_id` = '".$q_row42["id"]."'");
			}

			if ( ($gg == "snmp") || ($gg == "wmi_vbs") || ($gg == "wmi_perl") ) {
				$socket = @fsockopen(strtolower($q_row["hostname"]), $q_row3["services"], $error_number, $error, 5);

				if (!$socket) {
					$r2="down";
				}else{
					$r2="up";
					fclose ($socket);
				}
			}

			if ($r2 == 'down') {
				db_execute("UPDATE manage_host SET statut = 'prob' where id='" . $q_row["id"] . "'");
			}

			if ( ($r2 == $q_row3["statut"]) and ($reboot == '0'))  {
				print " -> no change\n";
			}else{
				print " -> change\n";
				manage_logger($q_row3["services"], $q_row["id"], $r2, "Service is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "port", "");
				//met  jour le statut
				db_execute("UPDATE manage_tcp SET statut = '" . $r2 ."' where id='" . $q_row["id"] . "' and services='" . $q_row3["services"] . "'");
			}
		} //end foreach

		////////////////////////////////////////////////////////////////////

		db_execute("delete FROM `manage_services` where id='" . $q_row["id"] . "' and oid not in (select data_local.snmp_index from data_input_data, data_template_data, data_local, data_template where data_input_data.data_input_field_id=(SELECT distinct(data_input_fields.id) FROM data_input, data_input_fields where data_input.type_id = 6 and data_input_fields.data_input_id=data_input.id and data_input_fields.name='Index Value') and data_input_data.data_template_data_id=data_template_data.id and data_template_data.local_data_id=data_local.id and data_template_data.data_template_id=data_template.id and data_template.name='Win Services' and data_local.host_id=" . $q_row["id"] . ")");

		$uptimearray3 = "SELECT * FROM `manage_services` where id='" . $q_row["id"] . "'";
		$queryrows3 = db_fetch_assoc($uptimearray3);

		global $config, $database_default;

		foreach ($queryrows3 as $q_row3) {
			print " + service " . $q_row3["name"] . " , was " . $q_row3["statut"];

			if ($gg == "rrdtool") {
				$uptimearray42 = "select manage_poller_output.local_data_id, manage_poller_output.output, data_input_data.value, data_local.snmp_index from data_input_data, data_template_data, data_local, data_template, manage_poller_output where data_input_data.data_input_field_id=(SELECT distinct(data_input_fields.id) FROM data_input, data_input_fields where data_input.type_id = 6 and data_input_fields.data_input_id=data_input.id and data_input_fields.name='Index Value') and data_input_data.data_template_data_id=data_template_data.id and data_template_data.local_data_id=data_local.id and data_template_data.data_template_id=data_template.id and data_template.name='Win Services' and data_local.host_id='".$q_row["id"]."' AND lower(data_input_data.value) = '".strtolower($q_row3["name"])."' AND data_local.id = manage_poller_output.local_data_id";
				$queryrows42 = db_fetch_assoc($uptimearray42);
				$r2 = "down";

				foreach ($queryrows42 as $q_row42) {
					if ($q_row42["output"] == "1") {
						$r2 = "up";
						print " (Data_local_id is : ".$q_row42['id'].")\n";
					}
				}

				db_execute("delete from `manage_poller_output` where `local_data_id` = '".$q_row42["id"]."'");
			}

			if ($gg == "snmp") {
			
//print "\nsnmp\n";
				if ($config["cacti_server_os"] == "unix") {
					$command_string = read_config_option("path_php_binary");
					$extra_args = "-q " . $config["base_path"] . "/scripts/win_services.php " . $q_row["hostname"] . " " . $q_row["snmp_community"] . " " . $q_row["snmp_version"] . " " . $q_row["id"] . " get servstate " . $q_row3["oid"];
				}else{
//print "\nwin\n";
					$command_string = read_config_option("path_php_binary");
//print "\n".$q_row["hostname"] . " " . $q_row["snmp_community"] . " " . $q_row["snmp_version"] . " " . $q_row["id"] . " get servstate " . $q_row3["oid"] . "\n";
					$extra_args = "-q " . strtolower($config["base_path"] . "/scripts/win_services.php " . $q_row["hostname"] . " " . $q_row["snmp_community"] . " " . $q_row["snmp_version"] . " " . $q_row["id"] . " get servstate " . $q_row3["oid"] );
				}

				$r2=exec_background($command_string, $extra_args);
//print "\n".$r2."-\n";
				if ($r2 == "1") {
					$r2 = "up";
				} else {
					$r2 = "down";
				}
			}

			if ($gg == "wmi_vbs") {
				$p = dirname(__FILE__);
				$command_string = "cscript.exe /nologo";
				$extra_args = $p . '/wmi/services.vbs '.$q_row["hostname"].' "'.$q_row3["name"].'"';
				$r2=exec_background($command_string, $extra_args);

				//case of access denied
				if ($r2 == "") {
					$r2="nopoll";
				}
			}

			if ($gg == "wmi_perl") {
				$p = dirname(__FILE__);
				$command_string = read_config_option("manage_perl");
				$extra_args = $p . '/wmi/services.pl '.$q_row["hostname"].' "'.$q_row3["name"].'"';
				$r2=exec_background($command_string, $extra_args);

				//case of access denied
				if ($r2 == "") {
					$r2="nopoll";
				}
			}

			if ( ($r2 == 'down') || ($r2 == 'nopoll') ) {
				db_execute("UPDATE manage_host SET statut = 'prob' where id='" . $q_row["id"] . "'");
			}

			if ( ($r2 == $q_row3["statut"]) and ($reboot == '0'))  {
				print " -> no change\n";
			}else{
				print " -> change\n";
				manage_logger(strtolower($q_row3["name"]), $q_row["id"], $r2, "Service is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "win_services", $q_row3["oid"]);
				//met  jour le statut
				db_execute("UPDATE manage_services SET statut = '" . $r2 ."' where id='" . $q_row["id"] . "' and oid='" . $q_row3["oid"] . "'");
			}
		} //end foreach

		////////////////////////////////////////////////////////////////////////////////////////////////////////

		$result = mysql_query("SELECT * FROM `manage_process` where id='" . $q_row["id"] . "'");
		$nb = mysql_num_rows($result);

		if ($nb <> 0) {
			global $config, $database_default;

			if ($gg == "snmp") {
				$arr_proc = cacti_snmp_walk($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.25.4.2.1.2", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
			}

			$stm=array();
			$stm_idx=0;
			$uptimearray40 = "SELECT name_cache FROM data_template_data, data_template, data_local WHERE data_template.name = 'SNMP  - Running Process Info' AND data_template.id = data_template_data.data_template_id AND data_local.id = data_template_data.local_data_id AND data_local.host_id = '" . $q_row["id"] . "'";
			$queryrows40 = db_fetch_assoc($uptimearray40);

			foreach ($queryrows40 as $q_row40) {
				$pos=strrpos($q_row40['name_cache']," - ")+3;
				$stm[$stm_idx]=substr($q_row40['name_cache'],$pos);
				$stm_idx++;
			}

			for ($ii=0; $ii < $nb; $ii++) {
				$row_arrayCde = mysql_fetch_row($result);
				print " + process ".$row_arrayCde[1];
				$ff=0;

				for ($jj=0; $jj < $stm_idx; $jj++) {
					if (strtolower($stm[$jj]) == strtolower($row_arrayCde[1])) {
						$ff=1;
					}
				}

				if ($ff == 0) {
					print " -> NOK -> delete";
					db_execute("delete FROM `manage_process` where id='" . $q_row["id"] . "' and LOWER(name) = '". strtolower($row_arrayCde[1])."'");
				}else{
					print " -> OK , was ".$row_arrayCde[3];
					$r2 = "down";

					if ($gg == "rrdtool") {
						$uptimearray41 = "SELECT * FROM data_template_data, data_template, data_local, manage_poller_output WHERE data_template.name = 'SNMP  - Running Process Info' AND data_template.id = data_template_data.data_template_id AND data_local.id = data_template_data.local_data_id AND data_local.host_id = '" . $q_row["id"] . "' AND data_template_data.name_cache LIKE '%".strtolower($row_arrayCde[1])."%' AND manage_poller_output.local_data_id = data_local.id AND manage_poller_output.rrd_name = 'proc_mem'";
						$queryrows41 = db_fetch_assoc($uptimearray41);

						foreach ($queryrows41 as $q_row41) {
							if ($q_row41["output"] <> "U") {
								$r2 = "up";

								print " (Data_local_id is : ".$q_row42['id'].")\n";
							}
						}

						db_execute("delete from `manage_poller_output` where `local_data_id` = '".$q_row42["id"]."'");
					}

					if ($gg == "snmp") {
						for ($i = 0; $i < sizeof($arr_proc); $i++) {
							if (strtolower($arr_proc[$i]["value"]) == strtolower($row_arrayCde[1])) {
								$r2 = "up";
							}
						}
					}

					if ($gg == "wmi_vbs") {
						$p = dirname(__FILE__);
						$command_string = "cscript.exe /nologo";
						$extra_args = $p . '/wmi/process.vbs '.$q_row["hostname"].' "'.strtolower($row_arrayCde[1]).'"';
						$r2=exec_background($command_string, $extra_args);
						
						//case of access denied
						if ($r2 == "") {
						  $r2="nopoll";
						}
					}

					if ($gg == "wmi_perl") {
						$p = dirname(__FILE__);
						$command_string = read_config_option("manage_perl");
						$extra_args = $p . '/wmi/process.pl '.$q_row["hostname"].' "'.strtolower($row_arrayCde[1]).'"';
						$r2=exec_background($command_string, $extra_args);
						
						//case of access denied
						if ($r2 == "") {
						  $r2="nopoll";
						}
					}

					if ( ($r2 == 'down') || ($r2 == 'nopoll') ) {
						db_execute("UPDATE manage_host SET statut = 'prob' where id='" . $q_row["id"] . "'");
					}

					if ( ($r2 == $row_arrayCde[3]) and ($reboot == '0'))  {
						print " -> no change\n";
					}else{
						print " -> change\n";
						manage_logger(strtolower($row_arrayCde[1]), $q_row["id"], $r2, "Process is ", $q_row["hostname"] , $q_row["description"], $old_uptime, $new_uptime, "win_process", strtolower($row_arrayCde[2]));
						//met  jour le statut
						db_execute("UPDATE manage_process SET statut = '" . $r2 ."' where id='" . $q_row["id"] . "' and tag='" . strtolower($row_arrayCde[2]) . "'");
					}
				}
			} //end foreach
		}
	} //end UP

	if ( ($r == 'down') and ( ($q_row["statut"] == 'up') || ($q_row["statut"] == 'nopoll')) ) {
		$today = getdate();
		$date = $today['year']."/".$today['mon']."/".$today['mday'].", ".$today['hours'].":".$today['minutes'].":".$today['seconds'];

		$uptimearray4 = "SELECT * FROM manage_tcp where id='" . $q_row["id"] . "'";
		$queryrows4 = db_fetch_assoc($uptimearray4);

		foreach ($queryrows4 as $q_row4) {
			db_execute("INSERT INTO manage_alerts ( idh , datetime , ids , message, ida, oid ) VALUES ('" . $q_row["id"] . "', '" . $date . "', '" . $q_row4["services"] . "', 'down', '', '')");
		}

		$uptimearray4 = "SELECT * FROM manage_services where id='" . $q_row["id"] . "'";
		$queryrows4 = db_fetch_assoc($uptimearray4);

		foreach ($queryrows4 as $q_row4) {
			db_execute("INSERT INTO manage_alerts ( idh , datetime , ids , message, ida, oid ) VALUES ('" . $q_row["id"] . "', '" . $date . "', '9999', 'down', '', '".$q_row4["oid"]."')");
		}

		$uptimearray4 = "SELECT * FROM manage_process where id='" . $q_row["id"] . "'";
		$queryrows4 = db_fetch_assoc($uptimearray4);

		foreach ($queryrows4 as $q_row4) {
			db_execute("INSERT INTO manage_alerts ( idh , datetime , ids , message, ida, oid ) VALUES ('" . $q_row["id"] . "', '" . $date . "', '9998', 'down', '', '".$q_row4["tag"]."')");
		}
	}
}

$today = getdate();
$poller_date = $today['year']."-".$today['mon']."-".$today['mday'].", at ".$today['hours'].":".$today['minutes'].":".$today['seconds'];
print "\n".$poller_date;
db_execute("UPDATE settings SET value = '" . $poller_date . "' where name='manage_date'");

function exec_background($filename, $args = "") {
	global $config;

	exec($filename . " " . $args, $output);

	return $output[0];
}

function manage_logger($svc, $id, $val, $typ, $hn, $hd, $ou, $nu, $t, $o) {
	$manage_events = read_config_option("manage_events");
	$manage_netsend_events = read_config_option("manage_netsend_events");
	$manage_netsend_method = read_config_option("manage_netsend_method");
	$netsend = read_config_option("manage_send");
	$perl = read_config_option("manage_perl");
	$today = getdate();
	$date = $today['year']."/".$today['mon']."/".$today['mday'].", ".$today['hours'].":".$today['minutes'].":".$today['seconds'];

	$global_alert_address = read_config_option("manage_global_email");
	$alert_address = $global_alert_address;
	$private_alert_address = db_fetch_cell("SELECT mail FROM `manage_host` WHERE id='" . $id . "'",'');
	if ($private_alert_address <> "") {
	  $alert_address = $private_alert_address;
	  $double_alert_address = read_config_option("manage_double_email");
	  if ($double_alert_address == "1") {
	    $alert_address .= ";".$global_alert_address;
	  }
	}
	
	$tt=$svc;
	if ($t == "win_services") {
		$tt="9999";
	}

	if ($t == "win_process") {
		$tt="9998";
	}

	$s="INSERT INTO manage_alerts ( idh , datetime , ids , message, ida, oid ) VALUES ('" . $id . "', '" . $date . "', '" . $tt . "', '" . $val . "', '', '".$o."')";
	db_execute($s);

	if ( ($manage_events <> '5') || ($manage_netsend_events <> '5') ) {
		print " + mail or netsend demande : " . $alert_address . "\n";
		$h='';

		if ($val == 'up') {
			if (($manage_events == '0') || ($manage_events == '3') || ($manage_netsend_events == '3') || ($manage_netsend_events == '0') ) {
				print " + OK up\n";
				$h='UP';
			}
		}

		if ($val == 'down') {
			if (($manage_events == '1') || ($manage_events == '3') || ($manage_events == '4') || ($manage_netsend_events == '1') || ($manage_netsend_events == '3') || ($manage_netsend_events == '4') ) {
				print " + OK down\n";
				$h='DOWN';
			}
		}

		if ($val == 'rebooted') {
			if (($manage_events == '2') || ($manage_events == '4') || ($manage_netsend_events == '2') || ($manage_netsend_events == '4') ) {
				print " + OK reboot\n";
				$h='Reboot';
			}
		}

		if ($h <> '') {
			if ($t == 'host') {
				$g='Host ';
			}

			if ($t == 'port') {
				$g='Port ' . strtolower($svc);
			}

			if ($t == 'win_services') {
				$g='Windows Service "' . strtolower($svc). '"';
			}

			if ($t == 'win_process') {
				$g='Windows Process "' . strtolower($svc). '"';
			}

			$h2=$h;
			if ($ou > 4285440000) {
				$h='Maybe false alert - Reboot';
			}

			$msg=$g . ' is ' . $h2 . '.';

			if ($h2 == 'Reboot') {
				$days=floor($ou/8640000);
				$r=$ou-$days*8640000;
				$hours=floor( $r/360000 );
				$r=$ou-$days*8640000-$hours*360000;
				$minutes=floor($r/6000);

				$days2=floor($nu/8640000);
				$r2=$nu-$days2*8640000;
				$hours2=floor( $r2/360000 );
				$r2=$nu-$days2*8640000-$hours2*360000;
				$minutes2=floor($r2/6000);

				$msg = 'Old uptime was '.$days . 'd ' . $hours . 'h ' . $minutes .'m. New uptime is '.$days2 . 'd ' . $hours2 . 'h ' . $minutes2;
			}

			if ($manage_events <> '5') {
			  $m = explode(";", $alert_address);
			  foreach ($m as $mm) {
				thold_mail($alert_address, '', $h . ' event detected for host ' . $hd . ' (' . $hn . ')', $msg, '');
			  }
			}

			if ($manage_netsend_events <> '5') {
				$winpc = explode(";",$netsend);

				foreach ($winpc as $machine) {
					if ($manage_netsend_method == '0') {
						$command_string = "net send ";
					}else{
						$p = dirname(__FILE__);
						$command_string = $perl." ".$p."/netsend.pl ";
					}

					$command_string .= $machine.' "'.$h.' event detected for host '.$hd.' ('.$hn.'). '.$msg.'"';
					$extra_args = "";
					exec($command_string, $extra_args);
				}
			}
		}else{
			print " + No mail or netsend for this event.\n";
		}
	}
}

?>

