<?php

function plugin_init_manage() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['manage'] = 'manage_show_tab';
	$plugin_hooks['top_graph_header_tabs']['manage'] = 'manage_show_tab';
	$plugin_hooks['config_arrays']['manage'] = 'manage_config_arrays';
	$plugin_hooks['poller_bottom']['manage'] = 'manage_poller_bottom';
	$plugin_hooks['draw_navigation_text']['manage'] = 'manage_draw_navigation_text';
	$plugin_hooks['config_form']['manage'] = 'manage_config_form';
	$plugin_hooks['api_device_save']['manage'] = 'manage_api_device_save';
	$plugin_hooks['config_settings']['manage'] = 'manage_config_settings';

//	$plugin_hooks['poller_on_demand']['manage'] = 'manage_poller_on_demand';
	$plugin_hooks['poller_output']['manage'] = 'manage_poller_output';
}

function manage_version () {
	return array( 'name' 		=> 'manage',
			'version' 	=> '0.5.1',
			'longname'	=> 'PHP Network Managing',
			'author'	=> 'Gilles Boulon',
			'homepage'	=> 'http://forums.cacti.net/viewtopic.php?t=13827',
			'email'		=> '',
			'url'		=> ''
			);
}

function manage_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();

	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["manage"] = array(
				"method" => "checkbox",
				"friendly_name" => "Manage Host",
				"description" => "Check this box to manage this host.",
				"value" => "|arg1:manage|",
				"default" => "off",
				"form_id" => false
			);
		}
	}
	$fields_host_edit = $fields_host_edit3;
}

function manage_setup_table () {
	global $config, $database_default;

	include_once($config["library_path"] . "/database.php");

	$p = dirname(__FILE__);

	include($p . '/manage_lib.php');

	$install = manage_check_version();

	if ($install == "full") {
		$sql = "alter table host add manage char(3) default '' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host ( id mediumint(8) unsigned NOT NULL default '0', uptime bigint(20) default NULL, type mediumint(8) unsigned NOT NULL default '0', services text, statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_method ( id mediumint(8) unsigned NOT NULL default '0', method text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_alerts (idh mediumint(8) unsigned NOT NULL default '0', datetime datetime NOT NULL default '0000-00-00 00:00:00', ids mediumint(8) unsigned default '0', message text, note text, ida mediumint(9) unsigned NOT NULL auto_increment, PRIMARY KEY  (ida))";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host_services ( id mediumint(8) unsigned NOT NULL default '0', services mediumint(8) unsigned default '', statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_events', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_poller', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_method', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_date', '0')";
		$result = mysql_query($sql) or die (mysql_error());
	}

	if ( ($install == "full") || ($install == "upgrade-0.1") ) {
		$sql = "ALTER TABLE manage_host ADD `force` MEDIUMINT(8) unsigned NOT NULL default '9'";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_device_type ( id MEDIUMINT(8) NOT NULL AUTO_INCREMENT , name TEXT, image TEXT, PRIMARY KEY ( id ) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (1, 'Windows 2003 Host', 'win2003.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (2, 'Windows XP Host', NULL)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (3, 'Windows 2000 Host', 'win2000.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (4, 'Windows NT4 Host', 'winnt.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (5, 'Windows 9x Host', NULL)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (6, 'Linux Host', 'linux.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (7, 'Router', 'router.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (8, 'Switch', 'switch.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_device_type VALUES (9, 'Other', 'other.png')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_templates ( id MEDIUMINT(8) NOT NULL auto_increment, name TEXT, tcp_ports TEXT, PRIMARY KEY  (id) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (1, 'Mail Server (Basic)', '110;25')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (2, 'Mail Server (Enhanced)', '110;995;25;143;993;80;443')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (3, 'Switch/Router', '23')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (4, 'Web Server', '80;443')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (5, 'LDAP Server - Windows 200x Domain Controler', '389')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_templates VALUES (6, 'DNS Server', '53')";
		$result = mysql_query($sql) or die (mysql_error());
	}

	if ( ($install == "full") || ($install == "upgrade-0.1") || ($install == "upgrade-0.2") ) {
		$sql = "alter table manage_host add `group` MEDIUMINT(8) default '0'";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_groups ( id MEDIUMINT(8) NOT NULL auto_increment, name TEXT, PRIMARY KEY  (id) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO manage_groups VALUES (1, 'Test')";
		$result = mysql_query($sql) or die (mysql_error());
	}

	if (($install == "full") || ($install == "upgrade-0.1") || ($install == "upgrade-0.2") || ($install == "upgrade-0.3")) {
		$sql = "CREATE TABLE manage_services ( id MEDIUMINT(8) NOT NULL, name TEXT, oid TEXT, statut TEXT )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_process ( id MEDIUMINT(8) NOT NULL, name TEXT, tag TEXT, statut TEXT )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_alerts ADD `oid` TEXT";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_use_patch', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_send', '')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_netsend_events', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_netsend_method', '1')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_list', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_list_separator', '25')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_full_separator', '6')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_simple_separator', '12')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_legend', 'on')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_poller_hosts', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_perl', 'c:/perl/bin/perl.exe')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_thold', '1')";
		$result = mysql_query($sql) or die (mysql_error());
	}

	
	if (($install == "full") || ($install == "upgrade-0.1") || ($install == "upgrade-0.2") || ($install == "upgrade-0.3") || ($install == "upgrade-0.4-2")) {
		$sql = "INSERT INTO settings VALUES ('manage_cycle_delay', '30')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_cycle_refresh', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_poller_output (local_data_id mediumint(8), output text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_poller_plus', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_host_services RENAME manage_tcp";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_sites ( id MEDIUMINT(8) NOT NULL auto_increment, name TEXT, PRIMARY KEY  (id) )";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_groups ADD site_id MEDIUMINT NOT NULL";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_order1', '1')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_order2', '2')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_order3', '3')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_order4', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_order5', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_host ADD `thresold_ref` MEDIUMINT(8) unsigned NOT NULL default '1'";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_host ADD `thresold` MEDIUMINT(8) unsigned NOT NULL default '0'";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "ALTER TABLE manage_host ADD `mail` TEXT";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_list_2', '2')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_theme', 'default')";
		$result = mysql_query($sql) or die (mysql_error());
	    $sql = "INSERT INTO settings VALUES ('manage_sound', '0')";
	    $result = mysql_query($sql) or die (mysql_error());
	    $sql = "INSERT INTO settings VALUES ('manage_global_email', '')";
	    $result = mysql_query($sql) or die (mysql_error());
	    $sql = "INSERT INTO settings VALUES ('manage_thold', '1')";
	    $result = mysql_query($sql) or die (mysql_error());
	}
}

function manage_poller_bottom () {
	global $config;

	manage_setup_table();
	$p = dirname(__FILE__);

	if ($config["cacti_server_os"] == "unix") {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . $p . "/poller_manage.php";
	} else {
		$v = db_fetch_cell("SELECT value FROM settings where name='manage_use_patch'");

		if ($v == 1) {
			$command_string = $p . "/poller_manage.bat";
			$extra_args = "";
		} else {
			$command_string = read_config_option("path_php_binary");
			$extra_args = "-q " . strtolower($p . "/poller_manage.php");
		}
	}

	$manage_poller = db_fetch_cell("select value from settings where name ='manage_poller'",'');

	if ($manage_poller == '0') {
		exec_background($command_string, $extra_args);
	}
}

function manage_api_device_save ($save) {
	if (isset($_POST['manage'])) {
		$save["manage"] = form_input_validate($_POST['manage'], "manage", "", true, 3);
	}else{
		$save['manage'] = form_input_validate('', "manage", "", true, 3);
	}

	return $save;
}

function manage_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;

	$user_auth_realms[56]='Use Manage';
	$user_auth_realm_filenames['manage.php'] = 56;
	$user_auth_realm_filenames['manage_list.php'] = 56;
	$user_auth_realm_filenames['manage_viewalerts.php'] = 56;
	$user_auth_realm_filenames['manage_types.php'] = 56;
    $user_auth_realm_filenames['manage_templates.php'] = 56;
	$user_auth_realm_filenames['manage_groups.php'] = 56;
	$user_auth_realm_filenames['manage_sites.php'] = 56;
	$user_auth_realm_filenames['manage_debug.php'] = 56;
	$user_auth_realm_filenames['manage_ajax.php'] = 56;

	$menu["Templates"]['plugins/manage/manage_templates.php'] = "Manage Templates";

	$menu2 = array ();
	foreach ($menu as $temp => $temp2 ) {
		$menu2[$temp] = $temp2;
		if ($temp == 'Management') {
			$menu2["Device Managing"]['plugins/manage/manage_list.php'] = "Devices";
			$menu2["Device Managing"]['plugins/manage/manage_types.php'] = "Device Types";
			$menu2["Device Managing"]['plugins/manage/manage_groups.php'] = "Groups";
			$menu2["Device Managing"]['plugins/manage/manage_sites.php'] = "Sites";
			$menu2["Device Managing"]['plugins/manage/manage_viewalerts.php'] = "Event Reporting";
		}
	}
	$menu = $menu2;
}


function manage_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;

	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('manage.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('manage.php')};
	}

	$authorized = db_fetch_row("SELECT user_auth_realm.realm_id
		FROM user_auth_realm
		WHERE user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		AND user_auth_realm.realm_id='$realm_id2'");

	if (($authorized) || (empty($realm_id2))) {
		$v1 = read_config_option("manage_list");
		load_current_session_value("simple", "sess_device_simple", $v1);

		$v = $_REQUEST["simple"];
		/*
		$v2="0";
		if (isset($_REQUEST["group"])) {
		  $v2 = $_REQUEST["group"];
		}

		$v3="0";
		if (isset($_REQUEST["err"])) {
		  $v3 = $_REQUEST["err"];
		}
		*/
		load_current_session_value("group", "sess_device_group", "0");
		load_current_session_value("err", "sess_device_err", "0");
		load_current_session_value("manage_sound_enable", "sess_device_manage_sound_enable", read_config_option("manage_sound"));
//		if (isset($_REQUEST["group"])) {
			$v .= "&group=".$_REQUEST["group"];
//		}
//		if (isset($_REQUEST["err"])) {
			$v .= "&err=".$_REQUEST["err"];
//		}
			$v .= "&manage_sound_enable=".$_REQUEST["manage_sound_enable"];
			
		print '<a href="' . $config['url_path'] . 'plugins/manage/manage.php?simple='.$v.'"><img src="' . $config['url_path'] . 'plugins/manage/images/tab_manage'; if (basename($_SERVER["PHP_SELF"]) == "manage.php") { print "_down"; } print '.gif" alt="Manage" align="absmiddle" border="0"></a>';

	}

	manage_setup_table();
}
function manage_draw_navigation_text ($nav) {
	$nav["manage.php:"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "manage.php", "level" => "1");
	$nav["manage_list.php:"] = array("title" => "Device Managing -> Devices", "mapping" => "index.php:", "url" => "manage_list.php", "level" => "1");
	$nav["manage_list.php:edit"] = array("title" => "Device Managing ->   Devices", "mapping" => "index.php:", "url" => "manage_list.php", "level" => "1");
	$nav["manage_list.php:actions"] = array("title" => "Device Managing ->   Devices", "mapping" => "index.php:", "url" => "manage_list.php", "level" => "1");
	$nav["manage_viewalerts.php:"] = array("title" => "Device Managing -> Event Reporting", "mapping" => "index.php:", "url" => "manage_viewalerts.php", "level" => "1");
	$nav["manage_viewalerts.php:actions"] = array("title" => "Device Managing -> Event Reporting", "mapping" => "index.php:", "url" => "manage_viewalerts.php", "level" => "1");
	$nav["manage_types.php:"] = array("title" => "Device Managing -> Device Types", "mapping" => "index.php:", "url" => "manage_types.php", "level" => "1");
	$nav["manage_types.php:actions"] = array("title" => "Device Managing -> Device Types", "mapping" => "index.php:", "url" => "manage_types.php", "level" => "1");
	$nav["manage_templates.php:"] = array("title" => "Manage Templates", "mapping" => "index.php:", "url" => "manage_templates.php", "level" => "1");
	$nav["manage_templates.php:actions"] = array("title" => "Manage Templates", "mapping" => "index.php:", "url" => "manage_templates.php", "level" => "1");
	$nav["manage_groups.php:"] = array("title" => "Manage Groups", "mapping" => "index.php:", "url" => "manage_groups.php", "level" => "1");
	$nav["manage_groups.php:actions"] = array("title" => "Manage Groups", "mapping" => "index.php:", "url" => "manage_groups.php", "level" => "1");
	$nav["manage_sites.php:"] = array("title" => "Manage Sites", "mapping" => "index.php:", "url" => "manage_sites.php", "level" => "1");
	$nav["manage_sites.php:actions"] = array("title" => "Manage Sites", "mapping" => "index.php:", "url" => "manage_sites.php", "level" => "1");

	return $nav;
}

function manage_config_settings () {
	global $tabs, $settings, $config;

//	$xxx = read_config_option("xxx");
//	if ($v1 == "1") {
	$tabs["misc"] = "Misc";
//	} else {
//	  $tabs["misc"] = "Manage";
//	}

//		global $config, $user_auth_realms, $user_auth_realm_filenames;


//		$v1 = read_config_option("manage_list");
//	$xxx = read_config_option("manage_list");

	$infos = manage_version ();

	$javascript = '<script type="text/javascript">
<!--
	function manage_popup(page) {
		window.open(page,"popup","");
	}
//-->
</script>';

	//addition code for themes
	$x = array();
	$p = dirname(__FILE__) . "/images/themes";
	$dir=opendir($p);
	while($file=readdir($dir)) {
		if ($file!="." and $file!="..") {
			if (is_dir($p."/".$file)) {
				$x[$file]=$file;
			}
		}
	}
	closedir($dir);

	$temp_manage = array(
		"manage_header" => array(
			"friendly_name" => "\n$javascript\n<table width='99%' cellspacing=0 cellpadding=0 align=left><tr><td class='textSubHeaderDark'>Plugin Manage ".$infos['version']."</td><td align=right class='textSubHeaderDark'><a href='javascript:manage_popup(\"plugins/manage/manage_debug.php\")' class='textSubHeaderDark'><font color=white>Debug (Click here to verify your tables)</font></a></td></tr></table>",
			"method" => "spacer",
		),
		"manage_method" => array(
			"friendly_name" => "Method to test connexion with host",
			"description" => "SNMP is recommended.<br>NOTE: ICMP Ping requires that the Cacti Service ID have root privileges in Unix.",
			"method" => "drop_array",
			"array" => array(0 => 'SNMP (uptime check)', 1 => 'SNMP (sysdescr check)', 2 => 'UDP Ping (with risk)', 3 => 'ICMP Ping (with risk)' ),
		),
		"manage_poller" => array(
			"friendly_name" => "Type of poller",
			"description" => "You can use the default task Cacti poller. If you need a faster poller, scheduled another task with 'poller_manage.php' (or 'poller_manage.bat' if you want to use Windows PHP Patch).",
			"method" => "drop_array",
			"array" => array(0 => 'Cacti poller', 1 => 'Manage poller'),
		),
		"manage_poller_plus" => array(
			"friendly_name" => "Manage performance",
			"description" => "To use 'Use rrdtool' choice, you will need the modified poller.",
			"method" => "drop_array",
			"array" => array(0 => 'Use SNMP', 1 => 'Use rrdtool', 2 => 'Use WMI (Vbs)', 3 => 'Use WMI (Perl)'),
		),
		"manage_use_patch" => array(
			"friendly_name" => "Use Windows PHP Patch",
			"description" => "Don't use. Select 'No'.",
			"method" => "drop_array",
			"array" => array(0 => 'No', 1 => 'Yes'),
		),
		"manage_events" => array(
			"friendly_name" => "Enable mail alerts",
			"description" => "You need to configure Thold Plugin to send mails.",
			"method" => "drop_array",
			"array" => array(0 => 'UP events', 1 => 'DOWN events', 2 => 'Reboot events', 3 => 'UP and DOWN events', 4 => 'DOWN and reboot events', 5 => 'None'),
		),
		"manage_global_email" => array(
			"friendly_name" => "Global e-mail to sending alerts",
			"description" => "';' is separator.",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_double_email" => array(
			"friendly_name" => "Use global e-mail even if private e-mail is selected for a device.",
			"description" => "Alerts will be sent to global <u>and</u> private e-mail.",
			"method" => "drop_array",
			"array" => array(0 => 'No', 1 => 'Yes'),
		),
		"manage_netsend_events" => array(
			"friendly_name" => "Enable 'net send' alerts",
			"description" => "Sends popups.",
			"method" => "drop_array",
			"array" => array(0 => 'UP events', 1 => 'DOWN events', 2 => 'Reboot events', 3 => 'UP and DOWN events', 4 => 'DOWN and reboot events', 5 => 'None'),
		),
		"manage_send" => array(
			"friendly_name" => "Stations that will receive 'net send' alerts",
			"description" => "';' is separator. Windows stations only.",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_netsend_method" => array(
			"friendly_name" => "'net send' method",
			"description" => "Perl module need Net::NetSend and Net-Nslookup.",
			"method" => "drop_array",
			"array" => array(0 => 'Windows build-in command', 1 => 'Perl module'),
		),
		"manage_perl" => array(
			"friendly_name" => "Perl Binary Path",
			"description" => "The path to your perl binary.",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_thold" => array(
			"friendly_name" => "Check thresholds",
			"description" => "Blink hostname when a threshold is breaked.<br>Firefox only.",
			"method" => "drop_array",
			"array" => array(0 => 'No', 1 => 'Yes'),
		),
		"manage_list" => array(
			"friendly_name" => "Default view",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'Full', 1 => 'Simple', 2 => 'List', 3 => 'By site'),
		),
		"manage_list_2" => array(
			"friendly_name" => "Secondary view",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'Full', 1 => 'Simple', 2 => 'List'),
		),
		"manage_theme" => array(
			"friendly_name" => "Theme for images",
			"description" => "Create a folder with your images in '<cacti>/plugins/manage/images/themes folder'.",
			"method" => "drop_array",
			"array" => $x,
		),
		"manage_sound" => array(
			"friendly_name" => "Sound",
			"description" => "Use sound from theme.",
			"method" => "checkbox",
		),
		"manage_list_separator" => array(
			"friendly_name" => "List view separator",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_full_separator" => array(
			"friendly_name" => "Hosts per line in Full view",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_simple_separator" => array(
			"friendly_name" => "Hosts per line in Simple view",
			"description" => "",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_legend" => array(
			"friendly_name" => "Show legend",
			"description" => "Check this to show a legend.",
			"method" => "checkbox",
		),
		"manage_poller_hosts" => array(
			"friendly_name" => "How many concurrent Manage Pollers can be run.",
			"description" => "To speed up poller time, you can choose to distribute hosts you manage in multiples pollers which will be run in same time.",
			"method" => "textbox",
			"max_length" => 255,
		),
		"manage_cycle_delay" => array(
			"friendly_name" => "Delay Interval",
			"description" => "This is the time in seconds before the next group is displayed (1 - 300).",
			"method" => "textbox",
			"max_length" => 3,
		),
		"manage_cycle_refresh" => array(
			"friendly_name" => "Delay Interval",
			"description" => "This is the time in seconds before the view is refreshed (1 - 300).",
			"method" => "textbox",
			"max_length" => 3,
		),
		"manage_order1" => array(
			"friendly_name" => "1st sort order",
			"description" => "",
			"method" => "drop_array",
			"array" => array(1 => 'Site name', 2 => 'Group name', 3 => 'Description', 4 => 'Hostname', 5 => 'Statut', 6 => 'Uptime', 7 => 'Device type', 0 => 'none'),
		),
		"manage_order2" => array(
			"friendly_name" => "2nd sort order",
			"description" => "",
			"method" => "drop_array",
			"array" => array(1 => 'Site name', 2 => 'Group name', 3 => 'Description', 4 => 'Hostname', 5 => 'Statut', 6 => 'Uptime', 7 => 'Device type', 0 => 'none'),
		),
		"manage_order3" => array(
			"friendly_name" => "3rd sort order",
			"description" => "",
			"method" => "drop_array",
			"array" => array(1 => 'Site name', 2 => 'Group name', 3 => 'Description', 4 => 'Hostname', 5 => 'Statut', 6 => 'Uptime', 7 => 'Device type', 0 => 'none'),
		),
		"manage_order4" => array(
			"friendly_name" => "4th sort order",
			"description" => "",
			"method" => "drop_array",
			"array" => array(1 => 'Site name', 2 => 'Group name', 3 => 'Description', 4 => 'Hostname', 5 => 'Statut', 6 => 'Uptime', 7 => 'Device type', 0 => 'none'),
		),
		"manage_order5" => array(
			"friendly_name" => "5th sort order",
			"description" => "",
			"method" => "drop_array",
			"array" => array(1 => 'Site name', 2 => 'Group name', 3 => 'Description', 4 => 'Hostname', 5 => 'Statut', 6 => 'Uptime', 7 => 'Device type', 0 => 'none'),
		)
//		"manage_use_misc" => array(
//			"friendly_name" => "",
//			"description" => "",
//			"method" => "drop_array",
//			"array" => array(1 => 'Misc', 2 => 'New Tab'),
//		)
	);

	if (isset($settings["misc"])) {
		$settings["misc"] = array_merge($settings["misc"], $temp_manage);
	} else {
		$settings["misc"]=$temp_manage;
	}
}

function manage_poller_output ($manage_rrd_update_array) {
	//print_r($rrd_update_array);
	$w = db_fetch_cell("SELECT value FROM settings where name='manage_poller_plus'");

	if ($w == 1) {
		print "Checking Manage...\n";
		$uptimearray42 = "SELECT data_local.id, data_local.data_template_id, data_local.snmp_index, data_local.host_id, data_template.name FROM data_local, data_template WHERE data_local.data_template_id = data_template.id AND (data_template.name = 'TCP' OR data_template.name = 'Win Services')";
		$queryrows42 = db_fetch_assoc($uptimearray42);

		foreach($manage_rrd_update_array as $item) {
			foreach ($queryrows42 as $q_row42) {
				if ($q_row42['id'] == $item['local_data_id']) {
					foreach($item as $itm) {
						foreach($itm as $it) {
							foreach($it as $i) {
								db_execute("insert into manage_poller_output (local_data_id,output) VALUES ('" . $item['local_data_id'] . "','" . $i . "')");
							}
						}
					}
				} //end if
			}
		}
	}

	return $manage_rrd_update_array;
}

/*
function manage_poller_on_demand($results) {
	global $config;

	error_reporting(0);

	$buffer_size = 15000;
	$outbuf      = "";
	$sql_prefix  = "INSERT INTO manage_poller_output (local_data_id, output) VALUES";
	$sql_suffix  = " ON DUPLICATE KEY UPDATE output=VALUES(output)";

	if (sizeof($results)) {
		$i = 1;

		foreach($results as $result) {
			if ($i == 1) {
				$delim = " ";
			}else{
				$delim = ", ";
			}

			$outbuf .=
				$delim . "('" .
				$result["local_data_id"] . "','" .
				$result["output"] .	"')";

			if (strlen($outbuf) > $buffer_size) {
				db_execute($sql_prefix . $outbuf . $sql_suffix);
				$outbuf = "";
				$i = 1;
			}else{
				$i++;
			}
		}

		if (strlen($outbuf)) {
			db_execute($sql_prefix . $outbuf . $sql_suffix);
		}
	}

	return TRUE;
}

*/

?>
